//------------------------------------------------------------------
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen
#property indicator_width1  2

//
//
//
//
//

extern int    Length      = 10;
extern int    Price       = PRICE_MEDIAN;
extern double Sensitivity =  1;

double adm[];
double rng[];
double rna[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0,adm);
      SetIndexBuffer(1,rng);
      SetIndexBuffer(2,rna);
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) rng[i] = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
   for(i=limit; i>=0; i--) rna[i] = iMAOnArray(rng,0,Length,0,MODE_EMA,i);
   for(i=limit; i>=0; i--)
   {
      double dev = iStdDevOnArray(rna,0,Length,0,MODE_SMA,i);
      double avg = iMA(NULL,0,Length,0,MODE_EMA,Price,i);
             adm[i] = avg-rna[i]/2.0+dev*Sensitivity;
   }
   return(0);
}

